import { GameDataInterface } from "novadatainterface/GameDataInterface";
import { Gettable } from "novadatainterface/Gettable";
import { NovaDataInterface } from "novadatainterface/NovaDataInterface";
import { NovaResources, NovaResourceType } from "./ResourceHolderBase";
import { BaseResource } from "./resourceParsers/NovaResourceBase";
import { NovaIDs } from "novadatainterface/NovaIDs";
declare type ParseFunction<T extends BaseResource, O> = (resource: T, errorFunc: (message: string) => void) => Promise<O>;
declare class NovaParse implements GameDataInterface {
    private pictImageGettable;
    private pictGettable;
    private pictMultiGettable;
    private spriteSheetDataGettable;
    private spriteSheetFramesGettable;
    private spriteSheetImageGettable;
    private spriteSheetMultiGettable;
    private shipParser;
    private shipPICTMap;
    private weaponOutfitMap;
    resourceNotFoundFunction: (message: string) => void;
    data: NovaDataInterface;
    path: string;
    private idSpaceHandler;
    readonly ids: Promise<NovaIDs>;
    readonly idSpace: Promise<NovaResources>;
    constructor(dataPath: string, strict?: boolean);
    private buildIDsForResource;
    private buildIDs;
    private buildData;
    makeGettable<T extends BaseResource, O>(resourceType: NovaResourceType, parseFunction: ParseFunction<T, O>): Gettable<O>;
    private makeShipPictMap;
    private makeWeaponOutfitMap;
    private getSpriteSheetData;
    private getSpriteSheetImage;
    private getSpriteSheetFrames;
    private getPictData;
    private getPictImage;
}
export { NovaParse };
